///////////////////////////////////////////////////////////
//  SafeRegion.cs
//  Implementation of the Class SafeRegion
//  Generated by Enterprise Architect
//  Created on:      22-mar-2008 20:21:22
//  Original author: piotrw
///////////////////////////////////////////////////////////




using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
namespace SimpleEngine.Core {
	
    /// <summary>
	/// This class calculates and stores data about rendering-save region. User
    /// for Xbox360 as the Windows rendering-save region is well defined.
	/// </summary>
    public class SafeRegion {

        protected GraphicsDeviceManager graphics;
        protected float leftTop = 0.05f;
        protected float rightBottom = 0.9f;
        protected Rectangle safeDimensions;
        protected Vector2 dimensions;
        protected int safeWidth;
        protected int safeHeight;

        public int SafeWidth
        {
            get { return safeWidth; }
        }

        public int SafeHeight
        {
            get { return safeHeight; }
        }

        public Rectangle SafeDimensions
        {
            get { return safeDimensions; }
        }

        public Vector2 Dimensions
        {
            get { return dimensions; }
        }

        public SafeRegion(GraphicsDeviceManager graphics)
        {
            this.graphics = graphics;
            safeDimensions = new Rectangle();
            this.CalculateSafeDimensions();
		}

        public SafeRegion(GraphicsDeviceManager graphics, float leftTop, float rightBottom)
        {
            this.graphics = graphics;
            this.leftTop = leftTop;
            this.rightBottom = rightBottom;
            safeDimensions = new Rectangle();
            this.CalculateSafeDimensions();

        }

        protected void CalculateSafeDimensions()
        {
            dimensions = new Vector2();
            dimensions.X = graphics.PreferredBackBufferWidth;
            dimensions.Y = graphics.PreferredBackBufferHeight;
//#if XBOX
            safeDimensions.X = (int)(dimensions.X * leftTop);
            safeDimensions.Y = (int)(dimensions.Y * leftTop);
            safeDimensions.Width = (int)(dimensions.X * rightBottom);
            safeDimensions.Height = (int)(dimensions.Y * rightBottom);
//#else
 //           safeDimensions.Width = (int)dimensions.X;
 //           safeDimensions.Height = (int)dimensions.Y;
//#endif

            safeWidth = safeDimensions.Width - safeDimensions.X;
            safeHeight = safeDimensions.Height - safeDimensions.Y;
        }

		~SafeRegion(){

		}

		public virtual void Dispose(){

		}

	}//end SafeRegion

}//end namespace Core